@ECHO OFF
SETLOCAL EnableDelayedExpansion
CLS

ECHO.
IF "%~1" == "-t" ECHO VIZZED RGR PLUGIN CACHE CLEANER (2015/05/18) - TEST MODE
IF NOT "%~1" == "-t" ECHO VIZZED RGR PLUGIN CACHE CLEANER (2015/05/18)
ECHO.
ECHO.
ECHO This script clear the cache of Vizzed RGR Plugin for registered and not registered user.
ECHO.

::--------------------------------
::------ Plugin Data Folder ------
::--------------------------------
ECHO.
ECHO Before using this script, please verify that the Plugin is correctly installed on your computer (you can download it from Vizzed itself).
ECHO.
ECHO From ^|^|Start -^> Programs -^> Vizzed Retro Game Room -^> Open Plugin Data Folder^|^| please check also if the path of the Plugin Data Folder is correct (open the file "..\clearcache\plugin-data-folder.txt" and edit it if the path is wrong).

IF NOT EXIST "plugin-data-folder.txt" (
  CALL:PrintError 2 
  GOTO End
)

::------ File size of 'plugin-data-folder.txt' ------
FOR /F "usebackq" %%A IN ('plugin-data-folder.txt') DO SET size=%%~zA
IF "%size%" == "0" (
  CALL:PrintError 3 
  GOTO End
)

::------ Extract the path from 'plugin-data-folder.txt' ------
FOR /F "delims=" %%i IN (plugin-data-folder.txt) DO ( 
  SET plgdatafolder=%%i
  GOTO Break
)
:Break
IF NOT EXIST "%plgdatafolder%" (
  ECHO.
  CALL:PrintError 1 
  GOTO End
)

ECHO It is currently set to "%plgdatafolder%".
ECHO.
ECHO.
ECHO The supported systems are: ATARI 2600, MAME
ECHO.
ECHO.

SET /P confirmReg=Do you want to continue [y/n]?:
IF "%confirmReg%" == "y" GOTO Start
IF "%confirmReg%" == "n" (
  ECHO.
  GOTO End
)

:Start
SET cmdPath=%plgdatafolder%
SET cmdPath2=%cmdPath%\Downloads
SET cmdPath3=%cmdPath%\Roms

IF NOT EXIST "%cmdPath2%" MD "%cmdPath%\Downloads"
IF NOT EXIST "%cmdPath3%" MD "%cmdPath%\Roms"

::------------------------------
::------ Test Mode On/off ------
::------------------------------
IF "%~1" == "-t" SET testmd=1
IF NOT "%~1" == "-t" SET testmd=0
  
::----------------------------------------------
::------ User (Registered/Not registered) ------
::----------------------------------------------
SET /A _Lines=0
FOR /F %%i IN ('DIR /B "%cmdPath%\User-*" "%cmdPath%\Rom*"^|FIND "" /v /c') DO SET /A _Lines=%%i

::--- User names ---
SET /A _n=0
FOR /F "tokens=* delims= " %%i IN ('DIR /B "%cmdPath%\User-*" "%cmdPath%\Rom*"') DO (
  SET /A _n=_n+1
  SET usrRegnm!_n!=%%i
)
SET usrGuest=User-guest
SET cmdPath4=%cmdPath%\%usrGuest%

::-----------------------------
::------ VizzedRgrPlugin ------
::-----------------------------
IF EXIST "%cmdPath%\VerifiedDownloadedZips.txt" DEL "%cmdPath%\VerifiedDownloadedZips.txt"

::---------------------------------------
::------ VizzedRgrPlugin\Downloads ------
::---------------------------------------
:VizDownloads:
ECHO.
ECHO.
ECHO If there are DOWNLOADED FILES that you want to keep, please copy them in the directory of the script (from "%cmdPath2%" to "..\clearcache\downloads").
ECHO After the cleaning, the script will copy them in the original directory.
CALL:Pause
ECHO.
ECHO ---- Searching for DOWNLOADED FILES ----
ECHO.
CALL:CheckEmptyDir 1,"%cmdPath2%",plugin
IF "%emptydir%" == "0" (
  CALL:DeleteFiles 1,"%cmdPath2%"
  CALL:ClearedMsg 1,"%cmdPath2%"
)
if not exist downloads (
  call:DirNotFound ..\clearcache\downloads
  goto VizRoms
)
CALL:CheckEmptyDir 1,downloads,clearcache
IF "%emptydir%" == "0" CALL:CopyFiles 1,"%cmdPath2%",downloads

::----------------------------------
::------ VizzedRgrPlugin\Roms ------
::----------------------------------
:VizRoms
ECHO.
ECHO.
ECHO If there are ROM FILES that you want to keep, please copy them in the directory of the script (from "%cmdPath3%" to "..\clearcache\roms").
ECHO After the cleaning, the script will copy them in the original directory.
CALL:Pause
ECHO.
ECHO ---- Searching for ROM FILES ----
ECHO.
CALL:CheckEmptyDir 1,"%cmdPath3%",plugin
IF "%emptydir%" == "0" (
  CALL:DeleteFiles 1,"%cmdPath3%"
  CALL:ClearedMsg 1,"%cmdPath3%"
)
if not exist roms (
  call:DirNotFound ..\clearcache\roms
  goto Start2
)
CALL:CheckEmptyDir 1,roms,clearcache
IF "%emptydir%" == "0" CALL:CopyFiles 1,"%cmdPath3%",roms

:Start2
ECHO.
SET /P confirmReg=Do you want to cancel the config files of the emulators [y/n]?:
IF "%confirmReg%" == "y" GOTO Start3
IF "%confirmReg%" == "n" (
  ECHO.
  GOTO End
)

::-----------------------
::------ Emulators ------
::-----------------------
:Start3
ECHO.
ECHO.
ECHO If there are CONFIG FILES that you want to keep, please copy them in the directories of the script (e.g.: from "%cmdPath%\User-xxxx\MAME" to "..\clearcache\systems\mame" for MAME, from "%cmdPath%\User-xxxx\MESS" to "..\clearcache\systems\mess" or "%cmdPath%\User-xxxx\MESS" to "..\clearcache\systems\mess-atari2600" for Atari 2600, and so on).
ECHO After the cleaning, the script will copy them in the original directories.
CALL:Pause

IF "%_Lines%" == "1" (
  CALL:PrintError 4
  GOTO End
)
IF "%_Lines%" == "2" GOTO EmulusrGuest

SET cmdPath5=%cmdPath%\%usrRegnm1%

:EmulusrReg
CALL:Mame "%cmdPath5%",%usrRegnm1%
CALL:Mess "%cmdPath5%",%usrRegnm1%
CALL:Pause

:EmulusrGuest
CALL:Mame "%cmdPath4%",%usrGuest%
CALL:Mess "%cmdPath4%",%usrGuest%

::-------------------------------
::------ End of the script ------
::-------------------------------
:End
ECHO.
SET /P DUMMY=Press ENTER to exit...
EXIT

::-----------------------
::------ Functions ------
::-----------------------
:CheckEmptyDir
rem echo %~2\%~3
if "%~1" == "1" (
  ( dir /b "%~2" | findstr . ) > nul && (
    set emptydir=0
  ) || (
    set emptydir=1
  )
)
if "%~1" == "2" (
  ( dir /b "%~2\%~3" | findstr . ) > nul && (
    set emptydir=0
  ) || (
    set emptydir=1
  )
)

if "%emptydir%" == "1" (
  if "%~1" == "1" (
    if "%testmd%" == "1" (
      if "%~3" == "plugin" echo "%~2" is empty.
      if not "%~3" == "plugin" echo "..\%~3\%~2" is empty.
      echo.
    )
  )
  if "%~1" == "2" (
    if "%testmd%" == "1" (
      if "%~4" == "plugin" echo "%~2\%~3" is empty.
      if not "%~4" == "plugin" echo "..\%~4\%~2\%~3" is empty.
      echo.
    )
  )
)
goto:eof

:DirNotFound
if "%testmd%" == "1" (
  echo "%~1" is not found.
  echo.
)
goto:eof

:DeleteFiles
if "%~1" == "1" del3 /s "%~2"
if "%~1" == "2" del3 /s "%~2\%~3"
echo.
goto:eof

:CopyFiles
if "%~1" == "1" xcopy /e /v /c /f /r /h /y "%~3\*.*" "%~2"
if "%~1" == "2" xcopy /e /v /c /f /r /h /y "%~3\%~4\*.*" "%~2\%~4"
if "%~1" == "3" xcopy /e /v /c /f /r /h /y "%~4\%~5\*.*" "%~2\%~3"
echo.
goto:eof

:ClearedMsg
if "%~1" == "1" echo "%~2" is cleared...
if "%~1" == "2" echo "%~2\%~3" is cleared...
echo.
goto:eof

:PrintError
echo.
if "%~1" == "1" echo Failed. The directory of the plugin is not found...
if "%~1" == "2" echo Failed. The file "..\clearcache\plugin-data-folder.txt" is not found and the script is unable to get the path of the Plugin Data Folder...
if "%~1" == "3" echo Failed. The file "..\clearcache\plugin-data-folder.txt" is empty and the script is unable to get the path of the Plugin Data Folder...
if "%~1" == "4" echo Failed. There is no user... have you tried to play at least one game?
echo.
goto:eof

:Pause
echo.
pause 
echo.
goto:eof

:Mame
echo.
echo ---- Searching for MAME FILES of %~2 ----
echo.
if not exist "%~1\MAME" (
  call:DirNotFound "%~1\MAME"
  goto MameEnd
)
call:CheckEmptyDir 2,"%~1",MAME,plugin
if "%emptydir%" == "0" (
  call:DeleteFiles 2,"%~1",MAME
  call:ClearedMsg 2,"%~1",MAME
)
if not exist "%~1\MAME-hsmode" (
  call:DirNotFound "%~1\MAME-hsmode"
  goto MameEnd
)
call:CheckEmptyDir 2,"%~1",MAME-hsmode,plugin
if "%emptydir%" == "0" (
  call:DeleteFiles 2,"%~1",MAME-hsmode
  call:ClearedMsg 2,"%~1",MAME-hsmode
)
if not exist systems\mame (
  call:DirNotFound ..\clearcache\systems\mame
  goto MameEnd
)
call:CheckEmptyDir 2,systems,mame,clearcache
IF "%emptydir%" == "0" call:CopyFiles 2,"%~1",systems,mame
if not exist systems\mame-hsmode (
  call:DirNotFound ..\clearcache\systems\mame-hsmode
  goto MameEnd
)
call:CheckEmptyDir 2,systems,mame-hsmode,clearcache
if "%emptydir%" == "0" call:CopyFiles 2,"%~1",systems,mame-hsmode
:MameEnd
goto:eof

:Mess
echo.
echo ---- Searching for MESS FILES of %~2 (Atari 2600) ----
echo.
if not exist "%~1\MESS" (
  call:DirNotFound "%~1\MESS"
  goto MessEnd
)
call:CheckEmptyDir 2,"%~1",MESS,plugin
if "%emptydir%" == "0" (
  call:DeleteFiles 2,"%~1",MESS
  call:ClearedMsg 2,"%~1",MESS
)
if not exist "%~1\MESS-hsmode" (
  call:DirNotFound "%~1\MESS-hsmode"
  goto MessEnd
)
call:CheckEmptyDir 2,"%~1",MESS-hsmode,plugin
if "%emptydir%" == "0" (
  call:DeleteFiles 2,"%~1",MESS-hsmode
  call:ClearedMsg 2,"%~1",MESS-hsmode
)
if not exist systems\mess (
  call:DirNotFound ..\clearcache\systems\mess
  goto MessEnd
)
call:CheckEmptyDir 2,systems,mess,clearcache
if "%emptydir%" == "0" call:CopyFiles 3,"%~1",MESS,systems,mess
if not exist systems\mess-hsmode (
  call:DirNotFound ..\clearcache\systems\mess-hsmode
  goto MessEnd
)
call:CheckEmptyDir 2,systems,mess-hsmode,clearcache
if "%emptydir%" == "0" call:CopyFiles 3,"%~1",MESS,systems,mess-hsmode
if not exist systems\mess-atari2600 (
  call:DirNotFound ..\clearcache\systems\mess-atari2600
  goto MessEnd
)
call:CheckEmptyDir 2,systems,mess-atari2600,clearcache
if "%emptydir%" == "0" call:CopyFiles 3,"%~1",MESS,systems,mess-atari2600
if not exist systems\mess-hsmode-atari2600 (
  call:DirNotFound ..\clearcache\systems\mess-hsmode-atari2600
  goto MessEnd
)
call:CheckEmptyDir 2,systems,mess-hsmode-atari2600,clearcache
if "%emptydir%" == "0" call:CopyFiles 3,"%~1",MESS-hsmode,systems,mess-hsmode-atari2600
:MessEnd
goto:eof